// Classe COiseau cre par Etienne Forest le 16 septembre 2012
// Cette classe implmente un oiseau migrateur qui drive de CPersonnage
// et qui a une direction de vol.  Un COiseau peut se dplacer dans sa
// direction, qui s'inverse lorsqu'arriv au bout de la fentre.
#pragma once
#include "Personnage.h"

const int Pas = 1; // Nb de pixels par dplacement

class COiseau : public CPersonnage
{	
public:
	enum Direction // Pour clarifier le code
	{ 
		Haut, Bas, Gauche, Droite
	};

	// Constructeur paramtrique, initialise la direction au hasard
   COiseau(Texture& LaTexture, int PosX, int PosY);

	// Accesseur et mutateur
	Direction GetDirection() const { return Direction_; }
	void SetDirection(Direction Dir) { Direction_ = Dir; }

	// Mthodes

	// Le pointeur vers l'oiseau est inutile  ce niveau mais la mthode est virtuelle
	// et le paramtre prendra son sens plus bas dans la hirarchie.
	// Dplace l'oiseau dans sa direction, inverse cette direction lorsque le dplacement
	// n'est pas possible (haut->bas, gauche->droite, et vice-versa)
	void virtual SeDeplacer(const COiseau* Oiseau);
	// Mthode virtuelle pure,  implmenter dans les enfants!
	bool virtual JeSuisUnMeneur() = 0;
	// Choisit une direction au hasard
	void SetDirectionHasard();
private:
	Direction Direction_;
};